#!/bin/bash

run_test () {
  for i in 0 1 2 4 8 16 8 4 2 1 0 ; do
    sync; echo 3 > /proc/sys/vm/drop_caches; service postgresql restart
    psql pgbench -e -c "set effective_io_concurrency=$i; set enable_indexscan=off; set enable_seqscan=off; explain (analyze, buffers)  select * from pgbench_accounts where aid between 1000 and 10000000 and abalance != 0;"
  done
}

createdb pgbench
pgbench -i -s 200 pgbench

psql pgbench -e -c "select version();" >summary.txt

psql pgbench -e -c "select array_agg(aid) from (select aid from pgbench_accounts order by ctid limit 20)_;" >>summary.txt
run_test >test01.txt
run_test >test02.txt
run_test >test03.txt
grep -E "effective_io_concurrency|Execution time" test01.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt
grep -E "effective_io_concurrency|Execution time" test02.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt
grep -E "effective_io_concurrency|Execution time" test03.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt

pg_dump -c -t pgbench_accounts pgbench >dump.sql

cat <(sed -n '1,/COPY pgbench_accounts/ p' dump.sql) \
    <(sed -n '/COPY pgbench_accounts/,/[\\][.]/ p' dump.sql | sed '1 d' | sed '$ d' | shuf) \
    <(sed -n '/[\\][.]/,$ p' dump.sql) \
    | psql pgbench

rm dump.sql

psql pgbench -e -c "select array_agg(aid) from (select aid from pgbench_accounts order by ctid limit 20)_;" >>summary.txt
run_test >test11.txt
run_test >test12.txt
run_test >test13.txt
grep -E "effective_io_concurrency|Execution time" test11.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt
grep -E "effective_io_concurrency|Execution time" test12.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt
grep -E "effective_io_concurrency|Execution time" test13.txt | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*\n/\1/' >>summary.txt
echo "" >>summary.txt

dropdb pgbench


